## Installation

Takuan can be built and installed manually from source in any recent GNU/Linux system using its Maven build files, but it is a long process.

However, it is much easier to install Takuan from one of our all-in-one binary distributions, following these steps:

1. Download the latest stable distribution appropriate for your system: 32-bit GNU/Linux systems should download [this one](https://neptuno.uca.es/nexus/service/local/artifact/maven/redirect?r=releases&g=es.uca.webservices&a=takuan-launcher&v=2.0&e=tar.gz&c=i386), and 64-bit GNU/Linux systems should download [this one](https://neptuno.uca.es/nexus/service/local/artifact/maven/redirect?r=releases&g=es.uca.webservices&a=takuan-launcher&v=2.0&e=tar.gz&c=amd64).
2. Unpack it to some directory, such as `$HOME/bin`.
3. Run it using  `$HOME/bin/takuan-launcher-2.0/takuan config.yaml`.

You might want to add @HOME/bin/takuan-launcher-2.0@ to your PATH, so you can run Takuan with just `takuan config.yaml`. The format of the YAML files accepted by Takuan is described in the README.txt file included with the binary distribution. The simplest possible configuration file would be:

```
bpts: my.bpts
bpel: my.bpel
dir: results
```

We also provide nightly releases of Takuan. To install these, we strongly recommend you use the [[Takuan Installation Script]]. You can use the same script to update your installation.

Please note that before using the [[Takuan NetBeans Plugin]], you will need to have a working Takuan installation.

## Using Takuan

* [[Using_invariants]] generated by Takuan
* [[Takuan_options]]
* [[Invoking Takuan]]
* [[Combining Takuan with the TestGenerator random test data generator]]

## Related publications

* [[ICE-B 2008]]: An Architecture for Dynamic Invariant Generation in WS-BPEL Compositions
* [[PRIS 2008]]: Framework para la Generación Dinámica de Invariantes en Composiciones de Servicios Web con WS-BPEL
* [[JSWEB 2008]]: Implementación de un framework para la generación dinámica de invariantes en composiciones de servicios web con WS-BPEL
* [[ECOWS 2008]]: Takuan: A Dynamic Invariant Generation System for WS-BPEL Compositions
* [[SOSE 2008]]: Improving Takuan to analyze a meta-search engine WS-BPEL composition
* [[ICWE 2009]]: Enhancing WS-BPEL Dynamic Invariant Generation using XML Schema and XPath Information
* [[PRIS 2009]]: La cobertura de los casos de prueba en la generación dinámica de invariantes en composiciones WS-BPEL
* [[JISBD 2009]]: Takuan: generación dinámica de invariantes en composiciones de servicios web con WS-BPEL
* [[JSWEB 2009]]: Los casos de prueba en la generación dinámica de invariantes en composiciones de servicios web con WS-BPEL
* [[Jornadas Predoctorales ESI]]:  Metodología para la prueba de caja blanca en WS-BPEL basada en mutaciones y generación dinámica de invariantes
* [[ICWE 2010]]: Takuan: a Tool for WS-BPEL Composition Testing using Dynamic Invariant Generation
* [[Service Life Cycle Tools and Technologies]] Service Composition Verification and Validation (book chapter)
* [[Expert Systems with Applications]] Automatic dynamic generation of likely invariants for WS-BPEL compositions (JCR paper)

## Presentations and other resources

* [[PFC_Ayllon_Takuan|Proyecto fin de carrera sobre Takuan]] (Spanish only)
* [[PFC_Santacruz|Proyecto fin de carrera sobre IdigInBPEL]] (Spanish only)
* [Cursos de doctorado ESI 2010](https://neptuno.uca.es/redmine/versions/download/1?attachment_id=140) (Spanish)
* [[Tesis_MPalomo|Tesis sobre Generación Dinámica de Invariantes en WS-BPEL]] (spanish only)

## Getting the source

Takuan is open source. All sources are available under the Subversion repository of our [[sources-fm:|shared code area]]. To checkout the latest version, you will need to install a Git client and issue the following command:

```
git clone https://gitlab.com/ucase/public/ws-bpel-testing-tools.git
```

Some [[Technical information about Takuan|additional technical details]] are also available.

## Recommendeds BibTeX entries

To cite Takuan:

```
@article{PalomoDuarte20145041,
  title = "Automatic dynamic generation of likely invariants for WS-BPEL compositions ",
  journal = "Expert Systems with Applications ",
  volume = "41",
  number = "11",
  pages = "5041 - 5055",
  year = "2014",
  issn = "0957-4174",
  doi = "http://dx.doi.org/10.1016/j.eswa.2014.01.037",
  url = "http://www.sciencedirect.com/science/article/pii/S095741741400061X",
  author = "Manuel Palomo-Duarte and Antonio García-Domínguez and Inmaculada Medina-Bulo",
  keywords = "Web service composition",
  keywords = "WS-BPEL",
  keywords = "Dynamic invariant generation",
  keywords = "White-box testing "
}
```

To cite Takuan project website (source code, installation, etc.):

```
@MISC {WebTakuan,
   author = {{Grupo SPI{\&}FM}},
   title = {Web oficial de {Takuan}},
   howpublished = {\url{http://neptuno.uca.es/~takuan}},
   note = {Registro Territorial de la Propiedad Intelectual de la Junta de Andalucía, c{\'o}digo CA-76-10}
}
```
